%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
:- import trie_interned/2,
	trie_interned/4 from intern.

:- import append/3 from basics.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% see_db(+StateId,-Facts)
see_db(StateId,log(Ins,Dels)):-
	tr_debug(on),
        stateRoot(StateRoot),
        insDelsRoot(InsDelsRoot),
        trie_interned(state(InsLeaf,DelsLeaf),StateRoot,StateId,_),
        trie_interned(Ins,InsDelsRoot,InsLeaf,_),
        trie_interned(Dels,InsDelsRoot,DelsLeaf,_),
        !.

see_db(StateId,Facts):-
        stateRoot(StateRoot),
        insDelsRoot(InsDelsRoot),
        trie_interned(state(InsLeaf,DelsLeaf),StateRoot,StateId,_),
        trie_interned(Ins,InsDelsRoot,InsLeaf,_),
        trie_interned(Dels,InsDelsRoot,DelsLeaf,_),
        findall(InitialFactId,initial_state(InitialFactId),InitialFactIdList),
        % add the inserts to the initial facts
        append(InitialFactIdList,Ins,IIL),
        sort(IIL,IILSorted),
        sort(Dels,DelsSorted),
        % delete deletes
        ordered_set_minus(IILSorted,DelsSorted,FactIds),
        facts_to_factids(Facts,FactIds),
        !.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
see_tabled_states(TabledStates):-
	stateRoot(StateRoot),
	insDelsRoot(InsDelsRoot),
	findall(InitialFactId,initial_state(InitialFactId),InitialFactIdList),
	findall(
		FactIds,
		(
			trie_interned(state(InsLeaf,DelsLeaf),StateRoot),
			trie_interned(Ins,InsDelsRoot,InsLeaf,_),
        		trie_interned(Dels,InsDelsRoot,DelsLeaf,_),
        		logs_to_state(InitialFactIdList,Ins,Dels,FactIds)
        	),TabledStates).
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
logs_to_state(InitialFactIdList,Ins,Dels,FactIds):-
	append(InitialFactIdList,Ins,IIL),
	sort(IIL,IILSorted),
        sort(Dels,DelsSorted),
        ordered_set_minus(IILSorted,DelsSorted,FactIds).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

