%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
:- import trie_interned/2,
	trie_interned/4 from intern.

:- import append/3 from basics.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
:-import new_trie/1,
        trie_bulk_insert/2,
        trie_intern/2,
        trie_intern/4,
        trie_interned/2,
        trie_interned/4 from intern.

:-import member/2,
        length/2,
        append/3,
        select/3 from basics.

:- import sort/2 from setof.

:- ['tr_utils.P'].

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% see_db(+StateId,-Facts)
see_db(log(_RelativeState1,TI1,TD1),log(LI1s,LD1s)):-
        tr_debug(on),
        trie_to_list(TI1,LI1),
        trie_to_list(TD1,LD1),
        sort(LI1,LI1s),
        sort(LD1,LD1s),
        !.

see_db(log(_RelativeState1,TI1,TD1),Facts):-
        trie_to_list(TI1,LI1),
        trie_to_list(TD1,LD1),
        sort(LI1,LI1s),
        sort(LD1,LD1s),
        initial_state_list(InitialFactIdList),
        merge_ord(InitialFactIdList,LI1s,IIL2),
        ordered_set_minus(IIL2,LD1s,FactIds),
        facts_to_factids(Facts,FactIds),
        !.

see_db(RelativeState1,log(Ins,Dels)):-
        number(RelativeState1),
        tr_debug(on),
        stateRoot(StateRoot),
        insDelsRoot(InsDelsRoot),
        trie_interned(state(InsLeaf,DelsLeaf),StateRoot,RelativeState1,_),
        trie_interned(Ins,InsDelsRoot,InsLeaf,_),
        trie_interned(Dels,InsDelsRoot,DelsLeaf,_),
        !.

see_db(RelativeState1,Facts):-
        number(RelativeState1),
        stateRoot(StateRoot),
        insDelsRoot(InsDelsRoot),
        trie_interned(state(InsLeaf,DelsLeaf),StateRoot,RelativeState1,_),
        trie_interned(Ins,InsDelsRoot,InsLeaf,_),
        trie_interned(Dels,InsDelsRoot,DelsLeaf,_),
        initial_state_list(InitialFactIdList),
        % add the inserts to the initial facts
        merge_ord(InitialFactIdList,Ins,IIL),
        % delete deletes
        ordered_set_minus(IIL,Dels,FactIds),
        facts_to_factids(Facts,FactIds),
        !.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
see_tabled_states(TabledStates):-
	stateRoot(StateRoot),
	insDelsRoot(InsDelsRoot),
	initial_state_list(InitialFactIdList),
	findall(
		FactIds,
		(
			trie_interned(state(InsLeaf,DelsLeaf),StateRoot),
			trie_interned(Ins,InsDelsRoot,InsLeaf,_),
        		trie_interned(Dels,InsDelsRoot,DelsLeaf,_),
        		logs_to_state(InitialFactIdList,Ins,Dels,FactIds)
        	),TabledStates).
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
logs_to_state(InitialFactIdList,Ins,Dels,FactIds):-
	merge_ord(InitialFactIdList,Ins,IIL),
        ordered_set_minus(IIL,Dels,FactIds).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

