dynamic_predicate(block,1).
dynamic_predicate(on,2).
dynamic_predicate(isclear,1).

tabled_predicate(stack,2).
tabled_predicate(unstack,1).
tabled_predicate(move,2).
%tabled_predicate(pickup,2).
%tabled_predicate(putdown,2).

% Actions
% tr_clause(+Head,+Body)
tr_clause(
	stack(0,Block),
		block(Block)).
tr_clause(
	stack(N,X),
		seq(N>0,
		seq(move(Y,X),
		seq(N1 is N-1,
		seq(stack(N1,Y),
		on(Y,X)))))).
tr_clause(
	move(X,Y),
		seq(block(X),
		seq(block(Y),
		seq(X\=Y,
		seq(pickup(X),
		putdown(X,Y)))))).

tr_clause(
	pickup(X),
		seq(isclear(X),
		seq(on(X,Y),
		seq(Y\=table,
		seq(del(on(X,Y)),
		ins(isclear(Y))))))).
tr_clause(
	pickup(X),
	seq(isclear(X),
		seq(on(X,table),
		del(on(X,table))))).

tr_clause(
	putdown(X,Y),
		seq(isclear(Y),
		seq(not(on(X,Z1)),
		seq(not(on(Z2,X)),
		seq(del(isclear(Y)),
		ins(on(X,Y))))))).
tr_clause(
	putdown(X,table),
		seq(not(on(X,Z1)),
		seq(not(on(Z2,X)),
		ins(on(X,table))))).

% if X is not free (there is a Y on X), then move all objects above it on the table
tr_clause(
	stack(N,X),
		seq(N>0,
		seq(on(Y,X),
		seq(unstack(Y),
		stack(N,X))))).

tr_clause(
	unstack(X),
		seq(isclear(X),
		on(X,table))).
tr_clause(
	unstack(X),
		seq(on(Y,X),
		seq(unstack(Y),
		unstack(X)))).
tr_clause(
	unstack(X),
		seq(isclear(X),
		seq(on(X,Y),
		seq(Y\=table,
		move(X,table))))).

% if X is on some object move X on the table
tr_clause(
	stack(N,X),
		seq(N>0,
		seq(isclear(X),
		seq(on(X,Y),
		seq(Y\=table,
		seq(move(X,table),
		stack(N,X))))))).
