:- import append/3 from basics.

% xsb -e "['generator.pl'],generator_chain(4),halt."
generator_chain(Size):-
	number_to_list(Size,SizeList),
        append(SizeList,".P",SizeList_P),
        atom_codes(Size_P,SizeList_P),
	% generate data
	append("chain_data_",SizeList_P,FileNameList1),
        atom_codes(FileName1,FileNameList1),
	open(FileName1,
        write,H1),
	write(H1,'% Defines the database state as: "tr_database(Fact)" rules.'),
        write(H1,'\n'),
	for_internal1(Size,H1),
        write(H1,'\n'),
	close(H1),
	% generate test
	append("chain_test_",SizeList_P,FileNameList2),
        atom_codes(FileName2,FileNameList2),
	open(FileName2,
        write,H2),
	write(H2,':- compiler_options([xpp_on]).'),
        write(H2,'\n'),
	write(H2,'#include "reach.P"\n'),
	write(H2,'#include "chain_data_'),
        write(H2,Size_P),
        write(H2,'"\n\n'),
	write(H2,'test_description(''Consuming paths.'').\n'),
	write(H2,'test_query(reach(X,Y)).'),
        write(H2,'\n\n'),
	close(H2).

for_internal1(Size,H):-
	for(X,1,Size),
        X2 is X+1,
	write(H,'tr_database(edge1('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge2('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge3('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge4('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge5('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge6('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge7('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge8('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
      	write(H,'tr_database(edge9('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	write(H,'tr_database(edge10('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	fail.
for_internal1(_,_).

% xsb -e "['generator.pl'],generator_chain_btc(5),halt."
generator_chain_btc(Size):-
	number_to_list(Size,SizeList),
        append(SizeList,"_btc.P",SizeList_P),
        %atom_codes(Size_P,SizeList_P),
	% generate test
	append("chain_test_",SizeList_P,FileNameList2),
        atom_codes(FileName2,FileNameList2),
	open(FileName2,write,H2),
	write(H2,'test_description(''Consuming paths.'').\n'),
	write(H2,'test_query(reach(X,Y)).'),
        write(H2,'\n\n'),
	%append("chain_data_",SizeList_P,FileNameList1),
        %atom_codes(FileName1,FileNameList1),
	write(H2,'% Defines the database state as: "tr_database(Fact)" rules.'),
        write(H2,'\n'),
	for_internal1(Size,H2),
        write(H2,'\n'),
	close(H2).

for(I,I,J) :- I =< J.
for(K,I,J) :- I < J,
	I1 is I + 1,
	for(K,I1,J).

number_to_list(Size,L):-
	number_to_list(Size,[],L).
number_to_list(Size,Prec,L):-
	Size < 10,
	Mod is Size + 48,
	L=[Mod|Prec],
	!.
number_to_list(Size,Prec,L):-
	Div is Size // 10,
	Mod is Size - (Div * 10) + 48,
	number_to_list(Div,[Mod|Prec],L).
