:- import append/3 from basics.

% xsb -e "['generator.pl'],generator_cycle(4),halt."
generator_cycle(Size):-
	number_to_list(Size,SizeList),
        atom_codes(SizeAtom,SizeList),
        append(SizeList,".P",SizeList_P),
        atom_codes(Size_P,SizeList_P),
	% generate data
	append("cycle_data_",SizeList_P,FileNameList1),
        atom_codes(FileName1,FileNameList1),
	open(FileName1,
        write,H1),
	write(H1,'% Defines the database state as: "tr_database(Fact)" rules.'),
        write(H1,'\n'),
	Size1 is Size-1,
	for_internal1(Size,H1),
        write(H1,'\n'),
	for_internal2(Size1,H1),
	write(H1,'tr_database(edge('),
        write(H1,Size),
        write(H1,',1)).'),
        write(H1,'\n'),
	close(H1),
	% generate test
	append("cycle_test_",SizeList_P,FileNameList2),
        atom_codes(FileName2,FileNameList2),
	open(FileName2,
        write,H2),
	write(H2,':- compiler_options([xpp_on]).'),
        write(H2,'\n'),
	write(H2,'#include "hamiltonian_cycle.P"\n'),
	write(H2,'#include "cycle_data_'),
        write(H2,Size_P),
        write(H2,'"\n\n'),
	write(H2,'test_description(''All hamiltonian cycles for cycles of '),
        write(H2,SizeAtom),
        write(H2,' edges.'').\n'),
	write(H2,'test_query(hamiltonian_cycle(X,Y)).'),
        write(H2,'\n\n'),
	close(H2).

generator_cycle_btc(Size):-
	number_to_list(Size,SizeList),
        atom_codes(SizeAtom,SizeList),
        append(SizeList,"_btc.P",SizeList_P),
        %atom_codes(Size_P,SizeList_P),
	% generate test
	append("cycle_test_",SizeList_P,FileNameList2),
        atom_codes(FileName2,FileNameList2),
	open(FileName2,
        write,H2),
	write(H2,'% Defines the database state as: "tr_database(Fact)" rules.'),
        write(H2,'\n'),
	Size1 is Size-1,
	for_internal1(Size,H2),
        write(H2,'\n'),
	for_internal2(Size1,H2),
	write(H2,'tr_database(edge('),
        write(H2,Size),
        write(H2,',1)).'),
        write(H2,'\n\n'),
	write(H2,'test_description(''All hamiltonian cycles for cycles of '),
        write(H2,SizeAtom),
        write(H2,' edges.'').\n'),
	write(H2,'test_query(hamiltonian_cycle(X,Y)).'),
        write(H2,'\n\n'),
	close(H2).

for_internal1(Size,H):-
	for(X,1,Size),
	write(H,'tr_database(vertex('),
        write(H,X),
        write(H,')).'),
        write(H,'\n'),
	fail.
for_internal1(_,_).

for_internal2(Size,H):-
	for(X,1,Size),
        X2 is X+1,
	write(H,'tr_database(edge('),
        write(H,X),
        write(H,','),
        write(H,X2),
        write(H,')).'),
        write(H,'\n'),
	fail.
for_internal2(_,_).

for(I,I,J) :- I =< J.
for(K,I,J) :- I < J,
	I1 is I + 1,
	for(K,I1,J).

number_to_list(Size,L):-
	number_to_list(Size,[],L).
number_to_list(Size,Prec,L):-
	Size < 10,
	Mod is Size + 48,
	L=[Mod|Prec],
	!.
number_to_list(Size,Prec,L):-
	Div is Size // 10,
	Mod is Size - (Div * 10) + 48,
	number_to_list(Div,[Mod|Prec],L).
